Make WordPress Core


Ignore:
Timestamp:
03/11/2025 02:17:41 PM (12 months ago)
Author:
TimothyBlynJacobs
Message:

REST API: Fix fatal error when making HEAD requests with _fields filter.

In [59889] the REST API controllers were adjusted to perform less work when responding to HEAD requests. The WP_REST_Response body would now be null, which caused issues with filters that expected the response body to be an array.

This commit sets the response body to be an empty array when preparing the response instead. The body will still be discarded, but this provides better backward comppatibility with code that assumes an array will be used.

See #56481.
Props antonvlasenko, timothyblynjacobs, mamaduka, wildworks.

File:
1 edited

Legend:

Unmodified
Added
Removed
  • trunk/tests/phpunit/tests/rest-api/rest-autosaves-controller.php

    r59899 r59970  
    197197        $this->assertSame( 200, $response->get_status(), 'The response status should be 200.' );
    198198        $this->assertSame( 0, $filter->get_call_count(), 'The "' . $hook_name . '" filter was called when it should not be for HEAD requests.' );
    199         $this->assertNull( $response->get_data(), 'The server should not generate a body in response to a HEAD request.' );
     199        $this->assertSame( array(), $response->get_data(), 'The server should not generate a body in response to a HEAD request.' );
    200200    }
    201201
     
    315315            return null;
    316316        }
    317         $this->assertNull( $response->get_data(), 'The server should not generate a body in response to a HEAD request.' );
     317        $this->assertSame( array(), $response->get_data(), 'The server should not generate a body in response to a HEAD request.' );
    318318    }
    319319
     
    890890        $this->assertSame( $autosave['id'], $data['id'], 'Original autosave was not returned' );
    891891    }
     892
     893    /**
     894     * @dataProvider data_head_request_with_specified_fields_returns_success_response
     895     * @ticket 56481
     896     *
     897     * @param string $path The path to test.
     898     */
     899    public function test_head_request_with_specified_fields_returns_success_response( $path ) {
     900        wp_set_current_user( self::$editor_id );
     901        $request = new WP_REST_Request( 'HEAD', sprintf( $path, self::$post_id, self::$autosave_post_id ) );
     902        $request->set_param( '_fields', 'id' );
     903        $server   = rest_get_server();
     904        $response = $server->dispatch( $request );
     905        add_filter( 'rest_post_dispatch', 'rest_filter_response_fields', 10, 3 );
     906        $response = apply_filters( 'rest_post_dispatch', $response, $server, $request );
     907        remove_filter( 'rest_post_dispatch', 'rest_filter_response_fields', 10 );
     908
     909        $this->assertSame( 200, $response->get_status(), 'The response status should be 200.' );
     910    }
     911
     912    /**
     913     * Data provider intended to provide paths for testing HEAD requests.
     914     *
     915     * @return array
     916     */
     917    public static function data_head_request_with_specified_fields_returns_success_response() {
     918        return array(
     919            'get_item request'  => array( '/wp/v2/posts/%d/autosaves/%d' ),
     920            'get_items request' => array( '/wp/v2/posts/%d' ),
     921        );
     922    }
    892923}
Note: See TracChangeset for help on using the changeset viewer.